Attribute VB_Name = "Windiing"
Option Explicit

Global XX As Single
Global YY As Single

Public Function BuildXfmr(Schemo As PictureBox, IW As Single) As Integer
'Create the transformer group.
Dim Gid As Integer
Dim I As Integer
Dim J As Integer
Dim N As Integer
Dim S As String
Dim What As String
Dim Term As Integer
Dim W As Integer
Dim LRPri As Integer   'Pin position: even = Left, Odd = right
Dim LRSec As Integer
Dim LastLRPri As Integer   'To set same start position for multifilar windings
Dim LastLRSec As Integer
Dim Side As String
Dim Done As Integer
Dim PW As Single   'Page Width
Dim PH As Single
Dim TH As Single
Dim BX As Single   'Last X
Dim BY As Single   'Last Y
'Dim X1 As Single
'Dim Y1 As Single
Dim CY As Single   'Additional space for interlayer legend
Dim EX As Single
Dim EY As Single
Dim DY As Single
Dim PBX As Single   'Pin locations an size
Dim PBY As Single
Dim PEX As Single
Dim PEY As Single
Dim PLen As Single
Dim PNum As Integer
Dim First As Boolean
    
    Schemo.Cls
'    PrepareRedimableArrays
    OX = 0
    OY = 0
    KZoom = 1
    PW = Schemo.Width   'Some shortcuts
    PH = Schemo.Height
    TH = Schemo.TextHeight(" ")
'    DY = TH
    DY = PH / 40  'Arbitrary smallest vertical unit. Should be adapted to Text Height . . .
    EX = 0.4 * PW
    PLen = PH / 30  'Pin lenght
    If GroupsCount > 0 Then 'Already exist
        Gid = 1         'Immuable group
        Groups(1).DX = 0
        Groups(1).DY = 0
        Groups(1).NodesCount = 0
        ReDim Groups(1).Nodes(0)
        Groups(1).ThingsCount = 0
        ReDim Groups(1).Things(0)
'        Groups(1).ThingsCount = 0
    Else
        Gid = NewGroup  'Create it
        First = True
    End If
    BX = 0
    BY = 0
    LRPri = 1   'By default start primary at left
    LRSec = 1   'By default start secondary at right
    For I = 0 To UBound(Windings)
        S = ""
        CY = 0
        With Windings(I)
            .TpLayer = .Turns / .Layers     ''''''''''''''''''''''''''''''''''''''''''' ??????????
            For J = 1 To .Wires
                If .ILThick > 0 Then
                    S = "" & .ILThick & " mm paper between layers"
                    CY = DY     'Some room for this legend
                End If
                If J = 1 Then   'Legend in first only if multifilar
'                    EY = (BY - .Layers * DY * 1.5 * Val(TbDia(.Usage))) - CY
                    EY = BY - DY - CY  'High enought to write text
                    If BY - EY < DY Then EY = BY - DY   'Force a minimal height
                    LastLRPri = LRPri
                    NewThing "R", 2, RGB(80, 40, 0), BX, BY, EX, EY, .Layers & "x" & .TpLayer / .Wires & "(" & .Turns / .Wires & ") turns " & TbDia(.Usage) & " mm dia." & S, Gid
                Else
                    EY = BY - DY    'Minimal height
                    NewThing "R", 2, RGB(80, 40, 0), BX, BY, EX, EY, "##### bifilaire #####", Gid
                    LRPri = LastLRPri     'All wires in multiwires begin at the same side
                End If
                
                If (LRPri + GetBit(StartSide, I)) Mod 2 > 0 Then    'Odd: input is at right
                    NewThing "L", 1, RGB(127, 0, 0), EX, BY - (DY / 4), EX + PLen, BY - (DY / 4), " ", Gid 'right input pin
                    PNum = MakeNode(Gid, EX + PLen, BY - (DY / 4))
                    NewThing "T", 2, RGB(127, 0, 0), EX + PLen / 4, BY - (DY / 5), 0, 0, str(PNum), Gid      'its number
                    NewThing "P", 2.5, RGB(127, 0, 0), EX, BY - (DY / 4), 0, 0, "", Gid                      'and its phase dot
                Else                    'Start at left
                    NewThing "L", 1, RGB(127, 0, 0), BX, BY - (DY / 4), BX - PLen, BY - (DY / 4), " ", Gid  'Left input pin
                    PNum = MakeNode(Gid, BX - PLen, BY - (DY / 4))
                    NewThing "T", 2, RGB(127, 0, 0), BX - PLen, BY - (DY / 5), 0, 0, str(PNum), Gid          'its number
                    NewThing "P", 2.5, RGB(127, 0, 0), BX, BY - (DY / 4), 0, 0, "", Gid                      'and its phase dot
                End If
                LRPri = LRPri + .Layers
                If (LRPri + GetBit(StartSide, I)) Mod 2 > 0 Then   'Output is at right
                    NewThing "L", 1, RGB(127, 0, 0), EX, EY + (DY / 4), EX + PLen, EY + (DY / 4), " ", Gid   'right output pin
                    PNum = MakeNode(Gid, EX + PLen, EY + (DY / 4))
                    NewThing "T", 2, RGB(127, 0, 0), EX + PLen / 4, EY + (DY / 5), 0, 0, str(PNum), Gid       'its number
                Else                    'Output is at left
                    NewThing "L", 1, RGB(127, 0, 0), BX, EY + (DY / 4), BX - PLen, EY + (DY / 4), " ", Gid 'left output pin
                    PNum = MakeNode(Gid, BX - PLen, EY + (DY / 4)) '
                    NewThing "T", 2, RGB(127, 0, 0), BX - PLen, EY + (DY / 5), 0, 0, str(PNum), Gid          'its number
                End If
                BY = EY
            Next
            If I < UBound(Windings) Then 'Add interwinding insulation
                EY = BY - DY   'Minimal height
                NewThing "R", 2, RGB(0, 80, 0), BX, BY, EX, EY, "MylarCellite: " & Format(IW, "0.0") & " mm", Gid
                BY = EY
            End If
        End With
    Next
    If XX = 0 And YY = 0 Then
        XX = SnapToGrid(0.2 * PW)
        YY = SnapToGrid(0.9 * PH)
'        MoveGroupA Gid, XX, YY
    End If
    MoveGroupA Gid, XX, YY
'    SetSa Gid, 0, EX, 0, EY
    BuildXfmr = Gid
'    If First Then DrawConnections
    RedrawAll
'    DrawGroups
'    DrawLinksA LinksColor, LinkSelColor
End Function

Private Sub DrawConnections()
'As defined in .mox file
Dim N As Integer    'Number of connections
Dim MoxFile As String
Dim I As Integer
Dim J As Integer
Dim CSection As String
Dim P As Integer
Dim S As String
Dim T As String
Dim Name As String
Dim X As Single
Dim Y As Single
Dim ToX As Single   'destination
Dim ToY As Single
Dim G As Integer
Dim Port As Integer


    MoxFile = GetIniString(INIFILE, "Global", "Mru")
    N = Val(GetIniString(MoxFile, "CONNECTS", "Num"))
    If N = 0 Then Exit Sub
    For I = 1 To N
        G = NewGroup
        CSection = "CONNECT" & Format(I)
        Name = GetIniString(MoxFile, CSection, "Name")
        S = GetIniString(MoxFile, CSection, "Pos")
        X = Val(Substring(S, 1, ","))
        Y = Val(Substring(S, 2, ","))
        NewThing "TB", 2, RGB(0, 0, 80), 0, 0, 0, 0, Name, G
        MoveGroupA G, X, Y
        S = GetIniString(MoxFile, CSection, "NodXY")
        X = Val(Substring(S, 1, ","))
        Y = Val(Substring(S, 2, ","))
        Port = MakeNode(G, X, Y)
        J = 1
        Do
            T = GetIniString(MoxFile, CSection, "Pins")
            P = Val(Substring(T, J, ","))
            If P > 0 Then
                MakeLink G, Port, 1, P
'                DrawLinkA G, Port, 1, P
                J = J + 1
            Else
                Exit Do
            End If
        Loop
    Next
End Sub

